<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
    use Modules\Lpj\Models\Branch;
    use Modules\Lpj\Models\Debiture;
    use Modules\Lpj\Models\TujuanPenilaian;
    use Modules\Usermanagement\Models\User;

    return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('permohonan', function (Blueprint $table) {
            $table->id();
            $table->string('nomor_registrasi')->unique();
            $table->date('tanggal_permohonan');
            $table->foreignIdFor(User::class)->constrained();
            $table->foreignIdFor(Branch::class)->constrained();
            $table->foreignIdFor(TujuanPenilaian::class)->constrained('tujuan_penilaian')->onDelete('cascade');
            $table->foreignIdFor(Debiture::class)->constrained('debitures')->onDelete('cascade');
            $table->boolean('status')->default(true)->nullable();
            $table->timestamps();
            $table->timestamp('authorized_at')->nullable();
            $table->char('authorized_status', 1)->nullable();
            $table->softDeletes();

            $table->unsignedBigInteger('created_by')->nullable();
            $table->unsignedBigInteger('updated_by')->nullable();
            $table->unsignedBigInteger('deleted_by')->nullable();
            $table->unsignedBigInteger('authorized_by')->nullable();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('permohonan');
    }
};
